#!/usr/bin/env python3
from Bio import SeqIO
from Bio import pairwise2
from Bio.pairwise2 import format_alignment
from align import myalign
import re
import os
os.chdir('/home/tanu/git/LSHTM_analysis/scripts/examples')


def main():
    """
    align ref_seq and pdb_seq
    # FIXME: pass command line args i.e filename
    
    """
    my_dict = {}
    align_fastas_to_align = open('align_fastas.txt', 'r') 
    for record in SeqIO.parse(align_fastas_to_align,"fasta"):
         myid = record.id
         seq = str(record.seq)
         my_dict.update({myid : seq})
         
    my_keys = list(my_dict.keys())
    my_ref_seq = my_dict[my_keys[0]]
    my_pdb_seq = my_dict[my_keys[1]]
        
    fasta_alignment = myalign(my_ref_seq, my_pdb_seq)
    print(fasta_alignment)
    print('class:', type(fasta_alignment))
    
   
if __name__ == '__main__':
    main()
